/* 
Mikroekonometria 
Zajęcia 2 - Wstepna analiza danych / Regresja liniowa / MNK 
CC BY: Wiktor Budziński
*/


// Zadanie 1. Przeprowadź wstępną analizę danych

cd "C:\Users\budzi\Documents\ME2024\ME2"

log using me2
clear all
cls

use me_wine.dta, clear
sum // Skrót od summarize
des // Skrót od describe


	// Przedstaw dane na wykresach

histogram Price
scatter Price Cases
twoway scatter Price Cases || qfit Price Cases
twoway scatter Price Score  || qfit Price Score 

gen  Variety = Nonvarietal + 2*Pinotnoir +3*Cabernet +4*Merlot+5*Shyrah
tab Variety

	// Przekodowanie zmiennej
replace Variety = 1 if Variety == 0
replace Variety = 0 if Nonvarietal == 1

label define variety_label 0 "Nonvarietal" 1 "Zinfandel" 2 "Pinotnoir" 3 "Cabernet" 4 "Merlot" 5 "Shyrah"
label values Variety variety_label

tab Variety
graph bar Price, over(Variety)

	// Policz korelację między Price, Cases oraz Score
	
pwcorr Price Cases Score, star(0.05)
	
	// Czy średnie ceny wina różnią się między stanami Kalifornia i Waszyngton
	
bysort washington: summarize Price
ttest Price, by(washington)

	// Czy w stanach Waszyngton i Kalifornia produkują wina różnego typu?

tab Variety washington
tab Variety washington, chi2

// Zadanie 2. Wykorzystując dane me_wine.dta przygotuj model regresji hedonicznej dla cen wina

	// Przeprowadź regresję objaśniającą ceny wina skupiając się na wpływie liczbie wyprodukowanych skrzynek wina oraz ocenie jego smaku

global vintage Vintage91-Vintage99 Vintage00
global region Napavalley bayareacentral sonoma southcoast carneros sierrafoothills mendocinolake washington 
global variety Nonvarietal Pinotnoir Cabernet Merlot Shyrah 
global type Reserve Vineyard Estate 
reg Price Cases Score Age $region $variety $type $vintage

// Dlaczego STATA pomija jeden z poziomow zmiennej Vintage?
global vintage Vintage91-Vintage99
reg Price Cases Score Age $region $variety $type $vintage

// Przeskalujmy zmienna Cases
replace Cases = Cases/100 
reg Price Cases Score Age $region $variety $type $vintage

// Podstawowe testy aby sprawdzic zalozenia w naszym modelu
predict reszty, residuals
hist reszty
estat ovtest // Test RESET na poprawność formy funkcyjnej
estat hettest // Defaultowy test Breusha-Pagana. Testuje czy wariancja zależy od wartości dopasowanych za pomocą MNK
sktest reszty  // Podstawowy test Jarque–Bera
sktest reszty, noadjust  // dodatkowa opcja

// Zilustrujmy związek między zmiennymi 
scatter Price Cases
scatter Price Score

// Spojrzmy na predykcje ceny wynikajace z naszego modelu
predict predykcja, xb
sum predykcja

gen LogPrice = log(Price)
reg LogPrice Cases Score Age $region $variety $type $vintage
display 100*(exp(.0554313 )-1)

// ZADANIE: Przeprowadz podstawowa diagnostyke dla nowego modelu




scatter LogPrice Cases
scatter LogPrice Score
twoway scatter reszty2 Cases || qfit reszty2 Cases
twoway scatter reszty2 Score || qfit reszty2 Score

log close